<template>
  <div class="sw-gs-client-name-modal">
    <SfModal class="sw-modal" :title="$t('Please insert your name')" :visible="isModalOpen" @close="onClose" persistent>
      <transition name="fade" mode="out-in">
        <div class="sw-gs-client-name-modal__wrapper">
          <p class="sw-gs-client-name-modal__info">
            <template v-if="showTokenPermissionsRequest">
              {{ $t('Your guide requested your permission to edit your cart.') }}
            </template>
            <template v-else>
              {{ $t('Please insert your name') }}
            </template>
          </p>
          <SwGsAttendeeNameForm @save-attendee-name="onAttendeeNameSave"/>
        </div>
      </transition>
    </SfModal>
  </div>
</template>

<script>
  import { watch } from '@vue/composition-api';
  import { SfModal } from "@storefront-ui/vue"
  import { useUIState } from "@shopware-pwa/composables"
  import SwGsAttendeeNameForm from "./SwGsAttendeeNameForm";
  import { useState } from "../logic/composables/useState";
  import { useMercureObserver } from "../logic/composables/useMercureObserver";
  import { useClearBodyScrollLock } from "../logic/composables/useClearBodyScrollLock";

  export default {
    name: "SwGsAttendeeWelcomeModal",
    components: {
      SfModal,
      SwGsAttendeeNameForm,
    },
    setup() {
      const { isOpen, switchState } = useUIState({ stateName: "GS_CLIENT_NAME_MODAL_STATE", })
      const { showTokenPermissionsRequest } = useState();
      const { requestedTokenPermissions } = useMercureObserver();

      useClearBodyScrollLock();

      watch(isOpen, () => {
        if (!isOpen.value && showTokenPermissionsRequest.value) {
          requestedTokenPermissions.value = null;
        }
      });

      function onClose() {
        switchState(false);
      }

      function onAttendeeNameSave() {
        switchState(false);
      }

      return {
        onAttendeeNameSave,
        onClose,
        isModalOpen: isOpen,
        showTokenPermissionsRequest,
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-client-name-modal {
    ::v-deep .sf-modal__container {
      z-index: var(--top-modal-container-z-index);
    }

    ::v-deep .sf-modal__overlay {
      z-index: var(--top-modal-overlay-z-index);
    }
  }

  .sw-gs-client-name-modal__info {
    padding-top: 20px;
  }

  #sw-login-modal {
    box-sizing: border-box;

    @include for-desktop {
      & > * {
        --modal-width: unset;
        --modal-content-padding: var(--spacer-xl) var(--spacer-base);
      }
      ::v-deep .sf-modal__container {
        min-width: 400px;
      }
    }
  }
</style>
